*" PACKAGE AADMIN !"  ᥤ롼
*"                  ver 1.00                   92/10/13 takepiro
***********************************************************************
      PROGRAM GAMRAS                           !" ᥤ롼
*
*"    Boussinesq ǥ
*"      one-level time integration
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [VAR]
      REAL       GAU   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GAV   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GAW   ( IDIM, JDIM, 0:KDIM )  !" ľ 
      REAL       GAT   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GATOR ( IDIM, JDIM, 0:KDIM )  !" ȥ 
      REAL       GAPOR ( IDIM, JDIM, 0:KDIM )  !" ݥ 
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      REAL       GTUA  ( IDIM, JDIM, 0:KDIM )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, 0:KDIM )  !" ̱ưѲ֣
      REAL       GTH   ( IDIM, JDIM, 0:KDIM )  !" ٻѲ  
*"       : <PHYSCS> ʻѲ(P) <DYNMCS> ʻѲ(P+D)
*
      INTEGER    ISTEP                 !" ̤ƥå׿
      INTEGER    ITA                   !" ̤(t), ɸñ
c$$$      INTEGER    IDATEA( 6 )           !" ǯʬ(ߡ)
      REAL       DELT                  !" ֹߦt(DAY)
      LOGICAL    OADVNC                !" 郎ʹԤ뤫ݤ
      LOGICAL    ORSTR                 !" ƽȯϤ뤫ݤ
*"       : 
*
*   [ONCE]
      INTEGER    ITSTRT                !" ׻ϻ(ɸñ)
      INTEGER    ITEND                 !" ׻λ(ɸñ)
      INTEGER    IORSTR                !" ϴֳ֡ƽȯ(ɸñ)
*"       : ¸ѥ᡼
*
      INTEGER    IDELT                 !" ɸֹ(SEC)
*"       : ֥ƥåץѥ᡼
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       ERI                          !" 
*     REAL       ERO                          !" 
*     REAL       ETA                          !" /
*"    COMMON /COMCON/ end
*"       : ʪѥ᡼
*
      REAL       ALAT  ( JDIM )        !" 
      REAL       DLAT  ( JDIM )        !" ٲٽ
      REAL       ALON  ( IDIM )        !" 
      REAL       DLON  ( IDIM )        !" ٲٽ
      REAL       ARAD  ( 0:KDIM )      !" ٥()
      REAL       DRAD  ( 0:KDIM )      !" ()
*"       : ɸ
*
*   [WORK]
      INTEGER    IUNIT                 !" ɸֹ
*
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )       !" ΰ
*
c$$$      DATA      IDATEA / 1992, 12, 18, 0, 0, 0/
*
#ifdef DEBUG
      external common_handler
      integer i, ieee_handler
      i = ieee_handler("set","common",common_handler )
      if( i.ne. 0 ) print *, "Could not establish fp signal handler"
#endif
*
*" << SETPUP :  >>
*
      CALL GLPGET( 'MSGUNIT', IUNIT )
      WRITE ( IUNIT, * ) ' 3DIM BOUSSINESQ MODEL GAMRAS'
     &                   //NAME
     &                   //' ver.1.0, 92/10/13'
*
      CALL CLCSTR ( 'SETUP' )
      CALL YPREP                       !" ƥ 
*
      CALL SETPAR                      !" ¸ѥ᡼
     O         ( ITSTRT , ITEND , IORSTR ,
     O           IDELT                      )
*
      CALL SETCOR                      !" ɸ
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           ARAD  , DRAD   )
*
      CALL RDSTRT                      !" ͤɤ߹ߤȺ
     O         ( GAU   , GAV   , GAW   , GAT   , 
     O           GATOR , GAPOR ,
     O           ITA   , ISTEP ,
     C           ITSTRT, ALAT  , DLAT  , ARAD  , DRAD     )
*
      CALL ADMXMN 
     I         ( GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR , ITA   , 'start GA'      )
*
      CALL SETTIM                      !" 򵭲 
     I         ( ITA   , ISTEP  )
      CALL AHSTRG                      !" ɸʿѽϤϿ
*
      CALL CLCEND ( 'SETUP' )
*
*  << LOOP : <************* ᥤ󡦥롼 >>
*
 5000 CONTINUE
*
#ifdef DEBUG
         CALL ADMXMN 
     I         ( GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR , ITA   , 'begin LOOP'    )
#endif
         ISTEP = ISTEP + 1
*
*     << START : ƥåפϤν >>
*
         CALL CLCSTR ( 'TIMCON' )
*
         CALL TIMSTP                   !"  
     O         ( DELT  , OADVNC , ORSTR ,
     I           ITA   , ISTEP  ,
     C           IDELT , ITEND , IORSTR          )
*
         CALL CLCEND ( 'TIMCON' )
*
*"    << INTEGR : ʬ >>
* 
         CALL CLCSTR ( 'DYNMCS' )
*
         CALL DYNMCS                   !" ϳعȻʬ
     M         ( GAU   , GAV   , GAW   , GAT   , 
     M           GATOR , GAPOR , 
     I           ITA   , DELT  , OADVNC,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
         CALL CLCEND ( 'DYNMCS' )
*
#ifdef DEBUG
         CALL ADMXMN 
     I         ( GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR , ITA   , 'after DYNMCS'    )
#endif
*
*"    << ADJST : ʬĴ >>
*
*"           Ĵʤ
*
*
*"    << OUTPUT : ǡ >>
         CALL    ADVSTP                !" ѿʤ
     O         ( ITA   ,  
     I           OADVNC          )
*
         IF ( OADVNC ) THEN
            CALL CLCSTR ( 'HISTIN' )
            CALL HISTIN ( GAU   , 'U'   ) !" ϥǡε
            CALL HISTIN ( GAV   , 'V'   )
            CALL HISTIN ( GAW   , 'W'   )
            CALL HISTIN ( GAT   , 'T'   )
            CALL HISTIN ( GATOR , 'TOR' )
            CALL HISTIN ( GAPOR , 'POR' )
            CALL CLCEND ( 'HISTIN' )
*
            CALL CLCSTR ( 'HISTOU' )
            CALL HISTRP
            CALL HISTOU                !" ǡ
            CALL CLCEND ( 'HISTOU' )
         ENDIF
*
*"    << NEXT : Υƥåפ >>
*
         CALL CLCSTR ( 'MISC' )
*
         IF ( ORSTR ) THEN
            CALL WRRSTR                !" ꥹȥե񤭹
     I         ( GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR ,
     I           ITA   , ISTEP                    )
         ENDIF
*
         CALL CLCEND ( 'MISC' )
*
*" << LEND : ᥤ󡦥롼׽ *************> >>
*
      IF ( .NOT. ( ITA .GE. ITEND )  ) GOTO  5000
*
      CALL ADMXMN 
     I      ( GAU   , GAV   , GAW   , GAT   , 
     I        GATOR , GAPOR , ITA   , 'end PROGRAM'    )

      CALL CLCOUT                      !" CPUֽ
      CALL YFINE                       !" ƥ
*
      STOP
      END
***********************************************************************
      SUBROUTINE AHSTRG                !" ɸʿѽϤϿ
*
*   [INTERN PARAM]
      INTEGER    ISTYPL
      DATA       ISTYPL / 1 /
      REAL       VMISS
*
      CALL GZDBGT ( 'MISS', VMISS )   !" »
*
      CALL     HISTRG                  !" ϤϿ
     I       ( 'U     ', 'u-velocity          ' ,'m/s   ', 'ALEV',
     I           VMISS , VMISS , 0.1   , 0.5   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'V     ', 'v-velocity          ' ,'m/s   ', 'ALEV',
     I           VMISS , VMISS , 0.1   , 0.5   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'W     ', 'w-velocity          ' ,'m/s   ', 'ALEV',
     I           VMISS , VMISS , 0.1   , 0.5   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'T     ', 'temperature         ' ,'K     ', 'ALEV',
     I           VMISS , VMISS , 0.1   , 0.5   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , ' '     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'TOR   ', 'toroidal potential  ' ,'1/s   ', 'ALEV',
     I           VMISS , VMISS , 0.1   , 0.5   , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , ' '     ,'(1PE12.3)' )
*
      CALL     HISTRG
     I       ( 'POR   ', 'poroidal potential  ' ,'1/s   ', 'ALEV',
     I           VMISS , VMISS , 0.1   , 0.5   , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , ' '     ,'(1PE12.3)' )
*
      RETURN
      END
*************************************************************************
      SUBROUTINE ADMXMN        !" debug monitor
     I         ( GDU   , GDV   , GDW   , GDT   , 
     I           GDTOR , GDPOR , IT    , HLABEL          )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#endif
*
*   [INPUT] 
      REAL       GDU   ( IDIM, JDIM, KMAX )  !"    
      REAL       GDV   ( IDIM, JDIM, KMAX )  !"    
      REAL       GDW   ( IDIM, JDIM, KMAX )  !" ľ 
      REAL       GDT   ( IDIM, JDIM, KMAX )  !"    
      REAL       GDTOR ( IDIM, JDIM, KMAX )  !" ȥ 
      REAL       GDPOR ( IDIM, JDIM, KMAX )  !" ݥ 

*
      INTEGER    IT
      CHARACTER  HLABEL *(*)
*
      WRITE ( 6,* ) HLABEL, ' IT= ', IT
      CALL MAXMIN( GDU,   IDIM, JDIM, KMAX, IDIM, JDIM, 'U'   )
      CALL MAXMIN( GDV,   IDIM, JDIM, KMAX, IDIM, JDIM, 'V'   )
      CALL MAXMIN( GDW,   IDIM, JDIM, KMAX, IDIM, JDIM, 'W'   )
      CALL MAXMIN( GDT,   IDIM, JDIM, KMAX, IDIM, JDIM, 'T'   )
      CALL MAXMIN( GDTOR, IDIM, JDIM, KMAX, IDIM, JDIM, 'TOR' )
      CALL MAXMIN( GDPOR, IDIM, JDIM, KMAX, IDIM, JDIM, 'POR' )
*
      RETURN
      END
